/* Copyright (C) 2005 Chris Vine

This program is distributed under the General Public Licence, version 2.
For particulars of this and relevant disclaimers see the file
COPYING distributed with the source files.

*/

#ifndef THREAD_H
#define THREAD_H

#include "prog_defs.h"

#include <sigc++/sigc++.h>
#include <glib/gthread.h>

#include "shared_ptr.h"



namespace Thread {

extern "C" void* thread_func(void*);

class Thread {
  GThread* g_thread_p;
  // private constructor - this class can only be created with Thread::start
  Thread(void) {}
  // and it cannot be copied
  Thread(const Thread&);
  Thread& operator=(const Thread&);
public:
  friend void* thread_func(void*);
  void join(void) {g_thread_join(g_thread_p);}
  static SharedPtr<Thread> start(const sigc::slot<void>& cb, bool joinable);
};

} // namespace Thread

#endif
